package de.mattv.quarry

import net.minecraft.core.BlockPos
import net.minecraft.nbt.CompoundTag

class QuarryChunk(val x: Int, val z: Int) {
    constructor(pos: BlockPos) : this(
            pos.x.let {
                var i = it
                if (i < 0) i -= 16
                (i / 16) * 16
            },
            pos.z.let {
                var i = it
                if (i < 0) i -= 16
                (i / 16) * 16
            }
    )

    constructor(tag: CompoundTag) : this(
            tag.getInt("x"),
            tag.getInt("z")
    )

    fun save(): CompoundTag = CompoundTag().apply {
        putInt("x", x)
        putInt("z", z)
    }

    fun asPos(): BlockPos = BlockPos(x, 0, z)

    fun min(other: QuarryChunk) = QuarryChunk(kotlin.math.min(x, other.x), kotlin.math.min(z, other.z))
    fun max(other: QuarryChunk) = QuarryChunk(kotlin.math.max(x, other.x), kotlin.math.max(z, other.z))
}