package de.mattv.quarry

import net.minecraft.world.item.BlockItem
import net.minecraft.world.item.CreativeModeTab
import net.minecraft.world.item.Item
import net.minecraft.world.level.block.Block
import net.minecraft.world.level.block.entity.BlockEntityType
import net.minecraftforge.event.RegistryEvent
import net.minecraftforge.eventbus.api.SubscribeEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.registries.DeferredRegister
import net.minecraftforge.registries.ForgeRegistries
import net.minecraftforge.registries.RegistryObject
import thedarkcolour.kotlinforforge.forge.MOD_BUS
import thedarkcolour.kotlinforforge.forge.registerObject

@Mod(QuarryMod.ID)
@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
object QuarryMod {
    const val ID = "mquarry"

    //val LOGGER: Logger = LogManager.getLogger(ID)

    val BLOCK_REGISTRY = DeferredRegister.create(ForgeRegistries.BLOCKS, ID)
    val TILES_REGISTRY = DeferredRegister.create(ForgeRegistries.BLOCK_ENTITIES, ID)
    val ITEM_REGISTRY = DeferredRegister.create(ForgeRegistries.ITEMS, ID)

    val QUARRY_BLOCK = BLOCK_REGISTRY.registerObject("quarry", ::QuarryBlock)
    val QUARRY_TILE = TILES_REGISTRY.registerObject("quarry") { BlockEntityType.Builder.of(::QuarryTile, QUARRY_BLOCK.get()).build(null) }
    val QUARRY_SPEED_UPGRADE = ITEM_REGISTRY.registerObject("upgrade_speed") { QuarryUpgrade(QuarryUpgrade.Type.SPEED) }
    val QUARRY_FORTUNE_UPGRADE = ITEM_REGISTRY.registerObject("upgrade_fortune") { QuarryUpgrade(QuarryUpgrade.Type.FORTUNE) }
    val QUARRY_ITEM = ITEM_REGISTRY.registerObject("quarry") { BlockItem(QUARRY_BLOCK.get(), Item.Properties().tab(CreativeModeTab.TAB_MISC)) }

    init {
        ITEM_REGISTRY.registerObject("controller", ::QuarryController)
        //LOGGER.log(Level.INFO, "MQuarry initializing")
        BLOCK_REGISTRY.register(MOD_BUS)
        TILES_REGISTRY.register(MOD_BUS)
        ITEM_REGISTRY.register(MOD_BUS)
    }
}